%% Reals: [0,1]
:- dynamic and_prod/3, and_godel/3, and_luka/3, or_prod/3, or_godel/3, or_luka/3, pri_prod/3,pri_sub/3,pri_add/3,pri_min/3,pri_max/3.

member(X):-number(X), 0=<X,X=<1.

leq(X,Y):-X =< Y.

top(1).
bot(0).

and_prod(X,Y,Z) :- pri_prod(X,Y,Z).
and_godel(X,Y,Z) :- pri_min(X,Y,Z).
and_luka(X,Y,Z) :- pri_add(X,Y,U1), pri_sub(U1,1,U2), pri_max(U2,0,Z).

or_prod(X,Y,Z) :- pri_prod(X,Y,U1), pri_add(X,Y,U2), pri_sub(U2,U1,Z).
or_godel(X,Y,Z) :- pri_max(X,Y,Z).
or_luka(X,Y,Z) :- pri_add(X,Y,U1), pri_min(U1,1,Z).

pri_prod(X,Y,Z) :- Z is X * Y.
pri_sub(X,Y,Z) :- Z is X-Y.
pri_add(X,Y,Z) :- Z is X+Y.
pri_min(X,Y,Z) :- (X=<Y,Z=X;X>Y,Z=Y).
pri_max(X,Y,Z) :- (X=<Y,Z=Y;X>Y,Z=X). % max(x,y) 
